/*

  GOOGLECALC.DLL

  Loadmodule for Litestep shell (and hereby compatible clones)
  Copyright (C) 2001-2002 Pavel Vitis
  pavel.vitis@seznam.cz
  http://blackdaemon.no-ip.org/litestep

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/****

TODO:

****/

#include <windows.h>
//#include <shellapi.h>
//#include <malloc.h>
#include <string.h>
#include "lsapi.h"
#include "main.h"

void bangEnable(HWND sender, LPCSTR args)
{
	module_enabled = true;
}

void bangDisable(HWND sender, LPCSTR args)
{
	module_enabled = false;
}

void bangToggle(HWND sender, LPCSTR args)
{
	module_enabled = !module_enabled;
}

void bangQuery(HWND sender, LPCSTR args)
{
	if (!module_enabled) {
		return;
	}
	if (args == NULL || strlen(args) == 0) {
		return;
	}

	char result[1024];
//	if (args[strlen(args)-1] == ' ') {
//		MessageBox( hLitestep, "args ended with space", ST_NAME " result", MB_OK | MB_ICONINFORMATION | MB_TOPMOST );
//	}

	if (queryGoogle(result, sizeof(result), args)) {
		if (run_on_result != NULL) {
			char *run = (char *)malloc(strlen(run_on_result)+1+strlen(result)+1);
			if (sprintf(run, run_on_result, result)) {
				LSExecute(hLitestep, run, SW_SHOWNORMAL);
			}
			free(run);
		}
		else {
			MessageBox( hLitestep, result, ST_NAME " result", MB_OK | MB_ICONINFORMATION | MB_TOPMOST );
		}
	}
}

void addBangs(void) {
	AddBangCommand("!googlecalc", &bangQuery);
}

void removeBangs(void) {
	RemoveBangCommand("!googlecalc");
}
