/*

  GOOGLECALC.DLL

  Loadmodule for Litestep shell (and hereby compatible clones)
  Copyright (C) 2001-2002 Pavel Vitis
  pavel.vitis@seznam.cz
  http://blackdaemon.no-ip.org/litestep

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/****

TODO:

****/

#include <windows.h>
//#include <shellapi.h>
//#include <malloc.h>
#include <string.h>
#include "lsapi.h"
#include "main.h"

HWND hLitestep = NULL;
HWND hDesktop = NULL;
HINSTANCE DLLInstance = NULL;
BOOL module_enabled = true;
char *run_on_result = NULL;
char *proxy_host = NULL;
int proxy_type = PROXYTYPE_DEFAULT;
BOOL verbose = FALSE;

void initConfig(void) {
	verbose = GetRCBool("GoogleCalcVerbose", TRUE);

	char buffer[2048];
	buffer[0] = '\0';
	if (GetRCLine("GoogleCalcOnResult", buffer, sizeof(buffer), NULL)) {
		int len = strlen(buffer);
//		MessageBox( hLitestep, buffer, ST_NAME "", MB_OK | MB_ICONINFORMATION | MB_TOPMOST );
		if (len > 0) {
			run_on_result = (char *)malloc(len+1);
			memcpy(run_on_result, buffer, len+1);
//			MessageBox( hLitestep, run_on_result, ST_NAME "", MB_OK | MB_ICONINFORMATION | MB_TOPMOST );
		}
	}

	proxy_type = PROXYTYPE_DEFAULT;

	if (GetRCString("GoogleCalcProxy", buffer, NULL, sizeof(buffer))) {
		int len = strlen(buffer);
//		MessageBox( hDesktop, buffer, ST_NAME "", MB_OK | MB_ICONINFORMATION | MB_TOPMOST );
		if (len > 0) {
			if (stricmp("none", buffer) == 0) {
				proxy_type = PROXYTYPE_NONE;
				if (verbose) {
					MessageBox( hLitestep, "Direct connection will be used", ST_NAME " proxy", MB_OK | MB_ICONINFORMATION | MB_TOPMOST );
				}
			}
			else {
				proxy_host = (char *)malloc(len+1);
				memcpy(proxy_host, buffer, len);
				proxy_host[len] = '\0';
				sprintf(buffer, "%s", proxy_host);
				if (verbose) {
					MessageBox( hLitestep, buffer, ST_NAME " proxy", MB_OK | MB_ICONINFORMATION | MB_TOPMOST );
				}
				proxy_type = PROXYTYPE_DEFINED;
			}
		}
	}
}

void doneConfig(void) {
	if (run_on_result != NULL) {
		free(run_on_result);
	}
	if (proxy_host != NULL) {
		free(proxy_host);
	}
}
