/*

  GOOGLECALC.DLL

  Loadmodule for Litestep shell (and hereby compatible clones)
  Copyright (C) 2001-2002 Pavel Vitis
  pavel.vitis@seznam.cz
  http://blackdaemon.no-ip.org/litestep

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/****

TODO:

****/

#include <windows.h>
//#include <shellapi.h>
//#include <malloc.h>
#include <string.h>
#include "lsapi.h"
#include "main.h"

char *steprcPath = NULL;
DWORD OSVer;

__declspec( dllexport ) int initModuleEx(HWND ParentWnd, HINSTANCE dllInst, LPCSTR szPath)
{
	OSVERSIONINFO osvinfo;

	// Get windows version
	osvinfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	if ( !GetVersionEx(&osvinfo) )
		return 1;
	OSVer = osvinfo.dwPlatformId;

	// Cache important window handles
	hLitestep = GetLitestepWnd();

	hDesktop = FindWindow("DesktopBackgroundClass", NULL);
	if (!hDesktop)
		hDesktop = GetDesktopWindow();

	DLLInstance = dllInst;
	steprcPath = strdup(szPath);

	initConfig();
	addBangs();

	return 0;
}

__declspec( dllexport ) void quitModule(HINSTANCE dllInst)
{
	removeBangs();
	doneConfig();
	
	if (NULL != steprcPath) {
		free(steprcPath);
	}
}

__declspec( dllexport ) int initModule(HWND ParentWnd, HINSTANCE dllInst, wharfDataType* wd)
{
	return initModuleEx (ParentWnd, dllInst, (wd)? wd->lsPath : NULL);
}


__declspec( dllexport ) BOOL WINAPI LibMain(HINSTANCE hDLLInst, DWORD fdwReason, LPVOID lpvReserved)
{
	UNREFERENCED_PARAMETER(lpvReserved);

	if (fdwReason == DLL_PROCESS_ATTACH)
	{
		DisableThreadLibraryCalls(hDLLInst);
	}
	return TRUE;
}
